local L = LibStub("AceLocale-3.0"):GetLocale("TrackOMatic", true);

--==================================================
-- Initialize the main menu
--==================================================
function TrackOMatic_InitMainMenu()
    CreateFrame("Frame", "TrackOMatic_TrackerMenu", UIParent, "UIDropDownMenuTemplate");
end

--==================================================
-- Handler for clicking the track button
-- (magnifying glass); Displays the main menu
--==================================================
function TrackOMatic_TrackButton_OnClick(self)
    local menu = {
        { text = L["ADDON_TITLE"], isTitle = true, notCheckable = true },
        { text = L["MENU_TRACK_REPUTATION"], notCheckable = true, func = function() ToggleCharacter("ReputationFrame"); end },
        { text = L["MENU_TRACK_PROFESSION"], notCheckable = true, func = function() ToggleSpellBook(BOOKTYPE_PROFESSION); end },
        { text = L["MENU_TRACK_CURRENCY"], notCheckable = true, func = function() ToggleCharacter("TokenFrame"); end },
        { text = L["MENU_TRACK_ACHIEVEMENT"], notCheckable = true, func = function() ToggleAchievementFrame(); end },
        { text = L["MENU_TRACK_MISC"], hasArrow = true, notCheckable = true, 
            menuList = {
                { text = L["MISC_INFO_XP"], disabled = TrackOMatic_IsTracked("misc", "xp"), notCheckable = true, func = function() TrackOMatic_AddMisc("xp"); end },
                { text = L["MISC_INFO_KILLS_TO_LEVEL"], disabled = TrackOMatic_IsTracked("misc", "grind"), notCheckable = true, func = function() TrackOMatic_AddMisc("grind"); end },
                { text = L["MISC_INFO_QUESTS_TO_LEVEL"], disabled = TrackOMatic_IsTracked("misc", "quest"), notCheckable = true, func = function() TrackOMatic_AddMisc("quest"); end },
                { text = L["MISC_INFO_GUILD_XP"], disabled = TrackOMatic_IsTracked("misc", "gxp"), notCheckable = true, func = function() TrackOMatic_AddMisc("gxp"); end },
                { text = L["MISC_INFO_GOLD"], disabled = TrackOMatic_IsTracked("misc", "gold"), notCheckable = true, func = function() TrackOMatic_AddMisc("gold"); end },
                { text = L["MISC_INFO_DURABILITY"], disabled = TrackOMatic_IsTracked("misc", "durability"), notCheckable = true, func = function() TrackOMatic_AddMisc("durability"); end },
            },
        },
        { text = L["MENU_TRACK_PLUGIN"], hasArrow = true, notCheckable = true,
            menuList = TrackOMatic_GetMenuPluginList(),
        },
        { text = L["MENU_TRACK_ITEM"], notCheckable = true, func = function() TrackOMatic_ItemSearch:Show(); end },
        { text = L["MENU_CLEAR_CATEGORY"], hasArrow = true, notCheckable = true,
            menuList = {
                { text = L["HEADER_REPUTATION"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("rep"), func = function() TrackOMatic_ClearCategory("rep"); end },
                { text = L["HEADER_PROFESSIONS"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("skill"), func = function() TrackOMatic_ClearCategory("skill"); end },
                { text = L["HEADER_MISC"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("misc"), func = function() TrackOMatic_ClearCategory("misc"); end },
                { text = L["HEADER_CURRENCY"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("currency"), func = function() TrackOMatic_ClearCategory("currency"); end },
                { text = L["HEADER_ITEMS"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("item"), func = function() TrackOMatic_ClearCategory("item"); end },
                { text = L["HEADER_ACHIEVEMENTS"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("ach"), func = function() TrackOMatic_ClearCategory("ach"); end },
                { text = L["HEADER_GUILD_ACHIEVEMENTS"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("guild_ach"), func = function() TrackOMatic_ClearCategory("guild_ach"); end },
                { text = L["HEADER_PLUGINS"], notCheckable = true, disabled = TrackOMatic_CategoryIsEmpty("plugin"), func = function() TrackOMatic_ClearCategory("plugin"); end },
            },
        },
        { text = L["MENU_CONFIGURE"], notCheckable = true, func = function() InterfaceOptionsFrame_OpenToCategory(TrackOMaticConfigContainer); end },
    };

    TrackOMatic_RunHooks("MAIN_MENU", menu);

    EasyMenu(menu, TrackOMatic_TrackerMenu, self, 0, 0, "MENU", 1);
end
