TRACKOMATIC_PLUGINS = {};
TRACKOMATIC_BAD_PLUGINS = {};

local L = LibStub("AceLocale-3.0"):GetLocale("TrackOMatic", true);

function TrackOMatic_SetPluginBar(data)

    local value, max, color, label, levelLabel, tooltipTitle, tooltipText = 1, 1, {r = 0.5, g = 0.5, b = 0.5}, data.name, "", "", "";
    local isGlowing, glowColor = false, {r = 1, g = 1, b = 1};
    local menu, clickFunc;
    if (TRACKOMATIC_PLUGINS[data.id]) then
        if (TRACKOMATIC_PLUGINS[data.id].onUpdate) then
            value, max, color, label, levelLabel, tooltipTitle, tooltipText, barMenu, isGlowing, glowColor = TRACKOMATIC_PLUGINS[data.id].onUpdate();
            menu = barMenu;
        end
        if (TRACKOMATIC_PLUGINS[data.id].onClick) then
            clickFunc = TRACKOMATIC_PLUGINS[data.id].onClick;
        end
    else
        tooltipTitle = L["MISSING_PLUGIN"];
        tooltipText = L["MISSING_PLUGIN_TOOLTIP"];
        levelLabel = L["NOT_LOADED"];
    end

    local menuTitle = data.name;

    return value, max, color, label, levelLabel, tooltipTitle, tooltipText, menuTitle, menu, clickFunc, isGlowing, glowColor;
end

function TrackOMatic_AddPlugin(id)
    if (TRACKOMATIC_PLUGINS[id]) then
        local cat = "plugin";
        if (TRACKOMATIC_PLUGINS[id].category) then
            if (TRACKOMATIC_CATEGORIES[TRACKOMATIC_PLUGINS[id].category]) then
                cat = TRACKOMATIC_PLUGINS[id].category;
            end
        end

        if (TRACKOMATIC_PLUGINS[id].requiresGoal) then
            TrackOMatic_ShowGoalInput(TRACKOMATIC_PLUGINS[id].name, function(value) TrackOMatic_FinishAddPlugin(cat, id, value); end);
        else
            TrackOMatic_FinishAddPlugin(cat, id);
        end

    else
        TrackOMatic_Message(L["PLUGIN_NOT_REGISTERED"]);
    end
end

function TrackOMatic_FinishAddPlugin(cat, id, goal)
    if (TrackOMatic_AddToCategory(cat, {id = id, isPlugin = true, name = TRACKOMATIC_PLUGINS[id].name})) then
        if (TRACKOMATIC_PLUGINS[id].onAdd) then
            TRACKOMATIC_PLUGINS[id].onAdd(goal);
        end
        TrackOMatic_Message(string.format(L["TRACKER_ADD_PLUGIN"], TRACKOMATIC_PLUGINS[id].name));
    end
end

function TrackOMatic_RemovePlugin(index, isSilent)
    local data = TrackOMatic_RemoveFromCategory("plugin", index);
    if ((not isSilent) and data) then
        if (TRACKOMATIC_PLUGINS[data.id]) then
            if (TRACKOMATIC_PLUGINS[data.id].onRemove) then
                TRACKOMATIC_PLUGINS[data.id].onRemove();
            end
        end
        TrackOMatic_Message(string.format(L["TRACKER_REMOVE_PLUGIN"], data.name));
    end
end

function TrackOMatic_GetMenuPluginList()

    menuList = {};

    for id, data in pairs(TRACKOMATIC_PLUGINS) do
        table.insert(menuList, { text = data.name .. " [" .. data.version .. "]", notCheckable = true, disabled = TrackOMatic_IsTracked(data.category, id, true), func = function() TrackOMatic_AddPlugin(id); end });
    end

    return menuList;

end
